// Code generated by sqlc-grpc (https://github.com/walterwanderley/sqlc-grpc).

package server

import (
	grpc_middleware "github.com/grpc-ecosystem/go-grpc-middleware"
	grpc_zap "github.com/grpc-ecosystem/go-grpc-middleware/logging/zap"
	grpc_recovery "github.com/grpc-ecosystem/go-grpc-middleware/recovery"
	grpc_ctxtags "github.com/grpc-ecosystem/go-grpc-middleware/tags"
	grpc_prometheus "github.com/grpc-ecosystem/go-grpc-prometheus"

	"go.uber.org/zap"
	"google.golang.org/grpc"
)

// Config represents the server configuration
type Config struct {
	ServiceName    string
	Port           int
	PrometheusPort int
	EnableCors     bool

	Middlewares []HttpMiddlewareType
}

// PrometheusEnabled check configuration
func (c Config) PrometheusEnabled() bool {
	return c.PrometheusPort > 0
}

func (c Config) grpcOpts(log *zap.Logger) []grpc.ServerOption {
	interceptors := make([]grpc.UnaryServerInterceptor, 0)
	interceptors = append(interceptors, grpc_ctxtags.UnaryServerInterceptor(grpc_ctxtags.WithFieldExtractor(grpc_ctxtags.CodeGenRequestFieldExtractor)))
	interceptors = append(interceptors, grpc_zap.UnaryServerInterceptor(log))
	interceptors = append(interceptors, grpc_recovery.UnaryServerInterceptor())
	if c.PrometheusEnabled() {
		interceptors = append(interceptors, grpc_prometheus.UnaryServerInterceptor)
	}

	interceptors = append(interceptors, errorMapper)

	opts := make([]grpc.ServerOption, 0)
	opts = append(opts, grpc_middleware.WithUnaryServerChain(interceptors...))
	return opts
}
